/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 * Generated by: OpenAPI Generator (https://openapi-generator.tech)
 */

package openapi

import (
	"time"
)

// ProductOrderUpdate - A Product Order is a type of order which  can  be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa, Skipped properties: id,href,orderDate
type ProductOrderUpdate struct {

	// Date when the order is cancelled. This is used when order is cancelled. 
	CancellationDate time.Time `json:"cancellationDate,omitempty"`

	// Reason why the order is cancelled. This is used when order is cancelled. 
	CancellationReason string `json:"cancellationReason,omitempty"`

	// Used to categorize the order from a business perspective that can be useful for the OM system (e.g. \"enterprise\", \"residential\", ...)
	Category string `json:"category,omitempty"`

	// Date when the order was completed
	CompletionDate time.Time `json:"completionDate,omitempty"`

	// Description of the product order
	Description string `json:"description,omitempty"`

	// Expected delivery date amended by the provider
	ExpectedCompletionDate time.Time `json:"expectedCompletionDate,omitempty"`

	// ID given by the consumer and only understandable by him (to facilitate his searches afterwards)
	ExternalId string `json:"externalId,omitempty"`

	// Contact attached to the order to send back information regarding this order
	NotificationContact string `json:"notificationContact,omitempty"`

	// A way that can be used by consumers to prioritize orders in OM system (from 0 to 4 : 0 is the highest priority, and 4 the lowest)
	Priority string `json:"priority,omitempty"`

	// Requested delivery date from the requestor perspective
	RequestedCompletionDate time.Time `json:"requestedCompletionDate,omitempty"`

	// Order fulfillment start date wished by the requestor. This is used when, for any reason, requestor cannot allow seller to begin to operationally begin the fulfillment before a date. 
	RequestedStartDate time.Time `json:"requestedStartDate,omitempty"`

	// A reference to an agreement defined in the context of the product order
	Agreement []AgreementRef `json:"agreement,omitempty"`

	BillingAccount BillingAccountRef `json:"billingAccount,omitempty"`

	Channel []RelatedChannel `json:"channel,omitempty"`

	Note []Note `json:"note,omitempty"`

	OrderTotalPrice []OrderPrice `json:"orderTotalPrice,omitempty"`

	Payment []PaymentRef `json:"payment,omitempty"`

	ProductOfferingQualification []ProductOfferingQualificationRef `json:"productOfferingQualification,omitempty"`

	ProductOrderItem []ProductOrderItem `json:"productOrderItem"`

	Quote []QuoteRef `json:"quote,omitempty"`

	RelatedParty []RelatedParty `json:"relatedParty,omitempty"`

	State ProductOrderStateType `json:"state,omitempty"`

	// When sub-classing, this defines the super-class
	BaseType string `json:"@baseType,omitempty"`

	// A URI to a JSON-Schema file that defines additional attributes and relationships
	SchemaLocation string `json:"@schemaLocation,omitempty"`

	// When sub-classing, this defines the sub-class entity name
	Type string `json:"@type,omitempty"`
}
